﻿@page "/showusers"
@inject NavigationManager NavigationManager
@inject HttpClient Http

<MudContainer>
	<MudPaper Class="pa-4">
		<MudText Typo="Typo.h5">User Information</MudText>
		@if (users == null)
		{
			<MudProgressCircular Indeterminate="true" />
		}
		else
		{
			<MudTable Items="@users">
				<HeaderContent>
					<MudTh>Firstname</MudTh>
					<MudTh>Lastname</MudTh>
					<MudTh>Email</MudTh>
					<MudTh>Roles</MudTh>
					@* <MudTh>Change password</MudTh>
					<MudTh>Change names</MudTh> *@
					<MudTh>Delete</MudTh>
				</HeaderContent>
				<RowTemplate>
					<MudTd DataLabel="Firstname">@context.FirstName</MudTd>
					<MudTd DataLabel="Lastname">@context.LastName</MudTd>
					<MudTd DataLabel="Email">@context.Email</MudTd>
					<MudTd DataLabel="Roles">
						@if (context.Roles != null && context.Roles.Any())
						{
							@string.Join(", ", context.Roles)
						}
						else
						{
							<span>No roles</span>
						}
					</MudTd>
					@* <MudTd DataLabel="Change password"><MudIcon Icon="@Icons.Material.Filled.BorderColor" Class="cursor-pointer" @onclick="@(() => ChangePassword(context))" /></MudTd>
					<MudTd DataLabel="Change first/last name"><MudIcon Icon="@Icons.Material.Filled.BorderColor" Class="cursor-pointer" @onclick="@(() => ChangeNames(context))" /></MudTd> *@
					<MudTd DataLabel="Delete"><MudIcon Icon="@Icons.Material.Filled.DeleteForever" Color="Color.Error" Class="cursor-pointer" @onclick="@(() => DeleteUser(context))" /></MudTd>
				</RowTemplate>
			</MudTable>
		}
	</MudPaper>
</MudContainer>

@code {
	private List<GetUserModel> users;

	protected override async Task OnInitializedAsync()
	{
		await LoadUsers();
	}

	protected async Task LoadUsers()
	{
		users = await Http.GetFromJsonAsync<List<GetUserModel>>("/api/Users");
	}

	protected async Task DeleteUser(GetUserModel user)
	{
		await Http.DeleteAsync($"/api/Users/{user.Id}");
		await LoadUsers();
	}

	protected async Task ChangePassword(GetUserModel user)
	{
		NavigationManager.NavigateTo("/changepassword");
	}

	protected async Task ChangeNames(GetUserModel user)
	{
		NavigationManager.NavigateTo("/changenames");
	}
}
